

#include <global.h>
#include <random_map.h>
#include <style.h>

#define NR_DECOR_OPTIONS 1

/* return a simple count of objects in the map at x,y. */

int obj_count_in_map(mapstruct *map,int x,int y) {
  int count=0;
  object *tmp;
  for(tmp=get_map_ob(map,x,y);tmp!=NULL;tmp=tmp->above)
	 count++;
  return count;
}
/* put the decor into the map.  Right now, it's very primitive. */

void put_decor(mapstruct *map,char **maze,char *decorstyle,int decor_option) {
  mapstruct *decor_map;
  char style_name[256];

  sprintf(style_name,"/styles/decorstyles");

  decor_map = find_style(style_name,decorstyle,-1);
  if(decor_map == NULL) return;
  /* pick a random option, only 1 option right now. */
  if(decor_option==0) {
    decor_option = RANDOM() % NR_DECOR_OPTIONS +1;
  };
  switch(decor_option) {
  case 1:  /* random placement of decor objects. */
    {
      int number_to_place = RANDOM() % ( (Xsize *Ysize) / 5);
      int failures=0;
      object *new_decor_object;
      while(failures < 100 && number_to_place  > 0) {
		  int x,y;
		  x = RANDOM() % (Xsize-2) +1;
		  y = RANDOM() % (Ysize-2) +1;
		  if(maze[x][y]==0 && obj_count_in_map(map,x,y)<2) /* empty */
			 { 
				object *this_object;
				new_decor_object = pick_random_object(decor_map);
				this_object = arch_to_object(new_decor_object->arch);
				copy_object(new_decor_object,this_object);
				this_object->x = x;
				this_object->y = y;
				/* it screws things up if decor can stop people */
				CLEAR_FLAG(this_object,FLAG_NO_PASS);
				insert_ob_in_map(this_object,map);
				number_to_place--;
			 }
		  else failures++;
      }
      break;

    }	
  }
}
